package proiektua;

import java.awt.BorderLayout;
import java.awt.Frame;
import java.awt.GraphicsEnvironment;
import java.awt.Point;

import javax.help.CSH;
import javax.help.HelpBroker;
import javax.help.HelpSet;
import javax.help.HelpSetException;
import javax.help.JHelp;
import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.JCheckBoxMenuItem;
import javax.swing.JFileChooser;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JFrame;
import javax.swing.JDesktopPane;
import javax.swing.JComboBox;
import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.IOException;
import java.net.URL;
import java.util.Vector;

import javax.swing.JLabel;
import javax.swing.JButton;
import javax.swing.filechooser.FileNameExtensionFilter;
import javax.xml.parsers.ParserConfigurationException;

import org.xml.sax.SAXException;

public class DatuakHasieratuFrame extends JFrame {
	private static final long serialVersionUID = 1L;
	private JMenuBar jJMenuBar = null;
	private JPanel jContentPane = null;
	private JDesktopPane jDesktopPane = null;
	private static DatuakHasieratuFrame frameBegin = null;
	private JComboBox jComboBoxPolicies = null;
	private JLabel jLabel = null;
	private JLabel jLabel1 = null;
	private JComboBox jComboBoxFrameAmount = null;
	private JLabel jLabelPageSecuence = null;
	private JComboBox jComboBox2 = null;
	private JComboBox jComboBox21 = null;
	private JComboBox jComboBox22 = null;
	private JComboBox jComboBox23 = null;
	private JComboBox jComboBox24 = null;
	private JComboBox jComboBox25 = null;
	private JComboBox jComboBox26 = null;
	private JComboBox jComboBox27 = null;
	private JComboBox jComboBox28 = null;
	private JComboBox jComboBox29 = null;
	private JComboBox jComboBox210 = null;
	private JComboBox jComboBox211 = null;
	
	private JMenu menuArchivo;
	private JMenuItem menuItemOpenFile;
	private JMenuItem menuItemExit;
	
	private JMenu menuEditar;
	private JMenu menuLanguage;
	
	private JMenuItem menuItemHelp;
	private JMenu menuHelp;
	
	private JCheckBoxMenuItem menuItemLanguages[];
	private JButton jButton = null;
	private JButton jButton1 = null;
	private  static int OrriSek[] = new int[12];
	private Action changeLanguageAction;  //  @jve:decl-index=0:
	private String xmlFile="languages.xml";  //  @jve:decl-index=0:
	private String xmlLanguageFile="";  //  @jve:decl-index=0:
	private String xmlErrorConf="";
	private String cfgConfFile="";
	//private String language;
	



	/**
	 * This is the default constructor
	 * @throws IOException 
	 * @throws SAXException 
	 * @throws ParserConfigurationException 
	 * @throws IOException 
	 * @throws SAXException 
	 * @throws ParserConfigurationException 
	 */
	public DatuakHasieratuFrame() throws ParserConfigurationException, SAXException, IOException {
		super();
		//language="euskera";
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 * @throws IOException 
	 * @throws SAXException 
	 * @throws ParserConfigurationException 
	 * @throws IOException 
	 * @throws SAXException 
	 * @throws ParserConfigurationException 
	 */
	private void initialize() throws ParserConfigurationException, SAXException, IOException {
		this.setSize(490, 284);
		this.setJMenuBar(getJJMenuBar());
		this.setContentPane(getJContentPane());		
	}

	private void setConfiguration(String path) {
		String policy=null, frameAmount=null;
		int value;
		String pageSecuence[] = new String[12];
		ReadXML xmlConfig,xmlLang;
		int error=0;
		
		try {
			xmlConfig = new ReadXML(path);
			policy=xmlConfig.getSectionNodeValue("policy","value");
			if(!policy.equals("OPT") && !policy.equals("FIFO") && !policy.equals("LRU")) {
				printError(xmlErrorConf);
				error=1;
			}
			frameAmount=xmlConfig.getSectionNodeValue("frameAmount","value");
			value = Integer.parseInt(frameAmount);
			if(value<2 || value>5) {
				printError(xmlErrorConf);
				error=1;
			}
			for(int i=0;i<12;i++) {
				pageSecuence[i]=xmlConfig.getSectionNodeValue("pageSequence","val"+(i+1));
				value = Integer.parseInt(pageSecuence[i]);
				if((value<0 || value>7) && error==0) {
					printError(xmlErrorConf);
					error=1;
				}
			}
			
		} catch (ParserConfigurationException e) {
			printError(xmlFile+": "+e.getMessage());
			error=1;
		} catch (SAXException e) {
			printError(xmlFile+": "+e.getMessage());
			error=1;
		} catch (IOException e) {
			printError(xmlFile+": "+e.getMessage());
			error=1;
		}
		if(error==0) {
			if(policy.equals("OPT")) {	
				jComboBoxPolicies.setSelectedIndex(0);
			}
			if(policy.equals("FIFO")) {	
				jComboBoxPolicies.setSelectedIndex(1);
			}
			if(policy.equals("LRU")) {	
				jComboBoxPolicies.setSelectedIndex(2);
			}
			value = Integer.parseInt(frameAmount);
			jComboBoxFrameAmount.setSelectedIndex(value - 2);
			
			value = Integer.parseInt(pageSecuence[0]);
			jComboBox2.setSelectedIndex(value);
			value = Integer.parseInt(pageSecuence[1]);
			jComboBox21.setSelectedIndex(value);
			value = Integer.parseInt(pageSecuence[2]);
			jComboBox22.setSelectedIndex(value);
			value = Integer.parseInt(pageSecuence[3]);
			jComboBox23.setSelectedIndex(value);
			value = Integer.parseInt(pageSecuence[4]);
			jComboBox24.setSelectedIndex(value);
			value = Integer.parseInt(pageSecuence[5]);
			jComboBox25.setSelectedIndex(value);
			value = Integer.parseInt(pageSecuence[6]);
			jComboBox26.setSelectedIndex(value);
			value = Integer.parseInt(pageSecuence[7]);
			jComboBox27.setSelectedIndex(value);
			value = Integer.parseInt(pageSecuence[8]);
			jComboBox28.setSelectedIndex(value);
			value = Integer.parseInt(pageSecuence[9]);
			jComboBox29.setSelectedIndex(value);
			value = Integer.parseInt(pageSecuence[10]);
			jComboBox210.setSelectedIndex(value);
			value = Integer.parseInt(pageSecuence[11]);
			jComboBox211.setSelectedIndex(value);
			
		}
		
		
	}
	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 * @throws IOException 
	 * @throws SAXException 
	 * @throws ParserConfigurationException 
	 */
	private JMenuBar getJJMenuBar() throws ParserConfigurationException, SAXException, IOException {
		if (jJMenuBar == null) {
			jJMenuBar = new JMenuBar();
			
			/***********************
			 *  FILE MENU
			 */
			menuArchivo = new JMenu ();
			jJMenuBar.add(menuArchivo);

			menuItemOpenFile = new JMenuItem(new AbstractAction() {
				private static final long serialVersionUID = 1L;
				public void actionPerformed(ActionEvent e) {
					JFileChooser chooser = new JFileChooser();
				    FileNameExtensionFilter filter = new FileNameExtensionFilter(
				    		cfgConfFile, "cfg");
				    chooser.setFileFilter(filter);
				    int returnVal = chooser.showOpenDialog(DatuakHasieratuFrame.this);
				    if(returnVal == JFileChooser.APPROVE_OPTION) {
				    	setConfiguration(chooser.getSelectedFile().getAbsolutePath());
				    }


				}
			});
			menuArchivo.add(menuItemOpenFile);
			
			menuArchivo.addSeparator();
			
			menuItemExit = new JMenuItem(new AbstractAction() {
				private static final long serialVersionUID = 1L;
				public void actionPerformed(ActionEvent e) {
					System.exit(0);
				}
			});
			menuArchivo.add(menuItemExit);
			
			/***********************
			 * EDIT MENU
			 */
			/*menuEditar = new JMenu ();
			jJMenuBar.add(menuEditar);*/
			
			/***********************
			 * LANGUAGES MENU
			 */
			menuLanguage = new JMenu();
			jJMenuBar.add(menuLanguage);
			
			changeLanguageAction = new AbstractAction() {
				private static final long serialVersionUID = 1L;
				public void actionPerformed(ActionEvent e) {
						try {
							boolean found=false;
							int i=0;
							while(!found) {
								if(menuItemLanguages[i].getText().equals(e.getActionCommand())) {
									found=true;
									setTextLanguage(i);
								}
								i++;
							}
							
						} catch (ParserConfigurationException e1) {
							printError(e1.getMessage());
						} catch (SAXException e1) {
							printError(e1.getMessage());
						} catch (IOException e1) {
							printError(e1.getMessage());
						}
	
				}
			};
			ReadXML xmlSections = new ReadXML("languages/languages.xml");
			Vector<String> sections= xmlSections.getSections();
			menuItemLanguages = new JCheckBoxMenuItem[sections.size()];
			for(int i=0;i<sections.size();i++) {
				menuItemLanguages[i] = new JCheckBoxMenuItem(changeLanguageAction);
				menuLanguage.add(menuItemLanguages[i]);
			}
			/***********************
			 *  HELP MENU
			 */
			menuHelp = new JMenu ();
			jJMenuBar.add(menuHelp);
			// Inicializamos la ayuda  
			//URL     hsURL = this.getClass().String helpHS = "myHelpSet.hs";
			
			URL url ;//= HelpSet.findHelpSet(DatuakHasieratuFrame.class.getClassLoader(), "/home/pron/Desktop/jh2.0/demos/hs/merge/Master.hs");
			//url = new URL("http","localhost","/home/pron/Desktop/jh2.0/demos/hs/merge/Master.hs");
			url = new URL("jar:file:OrdezkapenPolitika.jar!/merge/Master.hs");

			/*if (url == null) {
			url = new URL("jar:file:vetbp.jar!/merge/Master.hs");
			}*/
			System.out.println(url.getFile());
			
			HelpSet helpset=null;
			try {
				helpset = new HelpSet(null, url); 
			} catch (HelpSetException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}  
			HelpSet.Presentation hsp = helpset.getPresentation("MainWin");  
			                                  
			HelpBroker help_browser = helpset.createHelpBroker();     
			help_browser.setHelpSetPresentation(hsp);  
			
			menuItemHelp = new JMenuItem();
			menuItemHelp.addActionListener((ActionListener) new CSH.DisplayHelpFromSource( help_browser ));

			
			menuHelp.add(menuItemHelp);
			/*JMenu menuAyuda = new JMenu("Ayuda");
			jJMenuBar.add(menuAyuda);*/

		}
		return jJMenuBar;
	}
	
	public void setTextLanguage(int languageIndex) throws ParserConfigurationException, SAXException, IOException {
		String title;
		
		try {
			// Read from languages.xml what language file we'll use
			
			ReadXML xmlLanguage = new ReadXML("languages/" + xmlFile);
			Vector<String> sections= xmlLanguage.getSections();
			xmlLanguageFile = xmlLanguage.getSectionNodeValue(sections.get(languageIndex),"file");
			
			// Read configuration section
			ReadXML xmlConfig = new ReadXML("languages/" + xmlLanguageFile);
			title=xmlConfig.getSectionNodeValue("titles","mainFrame");
			this.setTitle(title);
			jLabelPageSecuence.setText(xmlConfig.getSectionNodeValue("labels","pageSecuence"));
			jLabel1.setText(xmlConfig.getSectionNodeValue("labels","frameAmount"));
			jLabel.setText(xmlConfig.getSectionNodeValue("labels","pageReplamentPolicy"));
			jButton.setText(xmlConfig.getSectionNodeValue("labels","randomPageSecuence"));
			jButton1.setText(xmlConfig.getSectionNodeValue("buttons","continue"));
			
			if(jComboBoxPolicies.getItemCount()==3) {
				int index=jComboBoxPolicies.getSelectedIndex();
				jComboBoxPolicies.removeAllItems();
				jComboBoxPolicies.addItem(xmlConfig.getSectionNodeValue("configurationOptions","policyOptimum"));
				jComboBoxPolicies.addItem(xmlConfig.getSectionNodeValue("configurationOptions","policyFIFO"));
				jComboBoxPolicies.addItem(xmlConfig.getSectionNodeValue("configurationOptions","policyLRU"));
				jComboBoxPolicies.setSelectedIndex(index);
			}
			// Read menu sections
			menuArchivo.setText(xmlConfig.getSectionNodeValue("menuFile","name"));
			menuItemOpenFile.setText(xmlConfig.getSectionNodeValue("menuFile","openFile"));
			cfgConfFile=xmlConfig.getSectionNodeValue("menuFile","confFile");
			menuItemExit.setText(xmlConfig.getSectionNodeValue("menuFile","exit"));
			//menuEditar.setText(xmlConfig.getSectionNodeValue("menuEdit","name"));
			menuLanguage.setText(xmlConfig.getSectionNodeValue("menuLang","name"));

			menuHelp.setText("Help");

			menuItemHelp.setText("Help");

		
			xmlErrorConf=xmlConfig.getSectionNodeValue("errors","xmlConf");
			
			for(int i=0;i<sections.size();i++) {
				menuItemLanguages[i].setText(xmlConfig.getSectionNodeValue("menuLang",sections.get(i)));
				if(i==languageIndex) {
					menuItemLanguages[i].setSelected(true);
				} else {
					menuItemLanguages[i].setSelected(false);
				}
			}
		} catch (IllegalArgumentException e) {
			printError(xmlFile+": "+e.getMessage());
		} catch (NullPointerException e) {
			printError(xmlFile+": "+e.getMessage());
		} catch (ParserConfigurationException e) {
			printError(xmlFile+": "+e.getMessage());
		} catch (SAXException e) {
			printError(xmlFile+": "+e.getMessage());
		} catch (IOException e) {
			printError(xmlFile+": "+e.getMessage());
		}

	}
	
	public void printError(String error) {
		JOptionPane.showMessageDialog(this,
			    error,
			    "Error",
			    JOptionPane.ERROR_MESSAGE);
	}
	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 * @throws IOException 
	 * @throws SAXException 
	 * @throws ParserConfigurationException 
	 */
	private JPanel getJContentPane() throws ParserConfigurationException, SAXException, IOException {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(new BorderLayout());
			jContentPane.add(getJDesktopPane(), BorderLayout.CENTER);
		}
		return jContentPane;
	}

	/**
	 * This method initializes jDesktopPane	
	 * 	
	 * @return javax.swing.JDesktopPane	
	 * @throws IOException 
	 * @throws SAXException 
	 * @throws ParserConfigurationException 
	 */
	private JDesktopPane getJDesktopPane() throws ParserConfigurationException, SAXException, IOException {
		
		if (jDesktopPane == null) {
			jLabelPageSecuence = new JLabel();
			jLabelPageSecuence.setBounds(new Rectangle(30, 105, 185, 20));
			jLabel1 = new JLabel();
			jLabel1.setBounds(new Rectangle(30, 66, 185, 20));
			jLabel = new JLabel();
			jLabel.setBounds(new Rectangle(30, 25, 185, 20));
			jDesktopPane = new JDesktopPane();
			jDesktopPane.add(getJComboBoxPolicies(), null);
			jDesktopPane.add(jLabel, null);
			jDesktopPane.add(jLabel1, null);
			jDesktopPane.add(getJComboBox1(), null);
			jDesktopPane.add(jLabelPageSecuence, null);
			jDesktopPane.add(getJComboBox2(), null);
			jDesktopPane.add(getJComboBox21(), null);
			jDesktopPane.add(getJComboBox22(), null);
			jDesktopPane.add(getJComboBox23(), null);
			jDesktopPane.add(getJComboBox24(), null);
			jDesktopPane.add(getJComboBox25(), null);
			jDesktopPane.add(getJComboBox26(), null);
			jDesktopPane.add(getJComboBox27(), null);
			jDesktopPane.add(getJComboBox28(), null);
			jDesktopPane.add(getJComboBox29(), null);
			jDesktopPane.add(getJComboBox210(), null);
			jDesktopPane.add(getJComboBox211(), null);
			jDesktopPane.add(getJButton(), null);
			jDesktopPane.add(getJButton1(), null);
			setTextLanguage(0);

		}
		return jDesktopPane;
	}

	
	/**
	 * This method initializes jComboBox	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	private JComboBox getJComboBoxPolicies() {
		if (jComboBoxPolicies == null) {
			jComboBoxPolicies = new JComboBox();
			jComboBoxPolicies.setBounds(new Rectangle(250, 24, 215, 24));
			jComboBoxPolicies.addItem("Algoritmo optimoa");
			jComboBoxPolicies.addItem("FIFO");
			jComboBoxPolicies.addItem("LRU politika");
		}
		return jComboBoxPolicies;
	}
	
	/**
	 * This method initializes jComboBox1	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	private JComboBox getJComboBox1() {
		if (jComboBoxFrameAmount == null) {
			jComboBoxFrameAmount = new JComboBox();
			jComboBoxFrameAmount.setBounds(new Rectangle(251, 64, 214, 26));
			for(int i=2;i<6;i++) {
				jComboBoxFrameAmount.addItem(Integer.toString(i));
			}
			jComboBoxFrameAmount.setSelectedIndex(1);
		}
		return jComboBoxFrameAmount;
	}

	/**
	 * This method initializes jComboBox2	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	private JComboBox getJComboBox2() {
		if (jComboBox2 == null) {
			jComboBox2 = new JComboBox();
			jComboBox2.setBounds(new Rectangle(250, 105, 50, 20));
			for(int i=0;i<MainMemory.MAXPAGES;i++) {
				jComboBox2.addItem(Integer.toString(i));
			}
		}
		return jComboBox2;
	}

	/**
	 * This method initializes jComboBox21	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	private JComboBox getJComboBox21() {
		if (jComboBox21 == null) {
			jComboBox21 = new JComboBox();
			jComboBox21.setBounds(new Rectangle(305, 105, 50, 20));
			for(int i=0;i<MainMemory.MAXPAGES;i++) {
				jComboBox21.addItem(Integer.toString(i));
			}
		}
		return jComboBox21;
	}

	/**
	 * This method initializes jComboBox22	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	private JComboBox getJComboBox22() {
		if (jComboBox22 == null) {
			jComboBox22 = new JComboBox();
			jComboBox22.setBounds(new Rectangle(360, 105, 50, 20));
			for(int i=0;i<MainMemory.MAXPAGES;i++) {
				jComboBox22.addItem(Integer.toString(i));
			}
		}
		return jComboBox22;
	}

	/**
	 * This method initializes jComboBox23	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	private JComboBox getJComboBox23() {
		if (jComboBox23 == null) {
			jComboBox23 = new JComboBox();
			jComboBox23.setBounds(new Rectangle(415, 105, 50, 20));
			for(int i=0;i<MainMemory.MAXPAGES;i++) {
				jComboBox23.addItem(Integer.toString(i));
			}
		}
		return jComboBox23;
	}

	/**
	 * This method initializes jComboBox24	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	private JComboBox getJComboBox24() {
		if (jComboBox24 == null) {
			jComboBox24 = new JComboBox();
			jComboBox24.setBounds(new Rectangle(250, 135, 50, 20));
			for(int i=0;i<MainMemory.MAXPAGES;i++) {
				jComboBox24.addItem(Integer.toString(i));
			}
		}
		return jComboBox24;
	}

	/**
	 * This method initializes jComboBox25	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	private JComboBox getJComboBox25() {
		if (jComboBox25 == null) {
			jComboBox25 = new JComboBox();
			jComboBox25.setBounds(new Rectangle(305, 135, 50, 20));
			for(int i=0;i<MainMemory.MAXPAGES;i++) {
				jComboBox25.addItem(Integer.toString(i));
			}
		}
		return jComboBox25;
	}

	/**
	 * This method initializes jComboBox26	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	private JComboBox getJComboBox26() {
		if (jComboBox26 == null) {
			jComboBox26 = new JComboBox();
			jComboBox26.setBounds(new Rectangle(360, 135, 50, 20));
			for(int i=0;i<MainMemory.MAXPAGES;i++) {
				jComboBox26.addItem(Integer.toString(i));
			}
		}
		return jComboBox26;
	}

	/**
	 * This method initializes jComboBox27	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	private JComboBox getJComboBox27() {
		if (jComboBox27 == null) {
			jComboBox27 = new JComboBox();
			jComboBox27.setBounds(new Rectangle(415, 135, 50, 20));
			for(int i=0;i<MainMemory.MAXPAGES;i++) {
				jComboBox27.addItem(Integer.toString(i));
			}
		}
		return jComboBox27;
	}

	/**
	 * This method initializes jComboBox28	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	private JComboBox getJComboBox28() {
		if (jComboBox28 == null) {
			jComboBox28 = new JComboBox();
			jComboBox28.setBounds(new Rectangle(250, 165, 50, 20));
			for(int i=0;i<MainMemory.MAXPAGES;i++) {
				jComboBox28.addItem(Integer.toString(i));
			}
		}
		return jComboBox28;
	}

	/**
	 * This method initializes jComboBox29	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	private JComboBox getJComboBox29() {
		if (jComboBox29 == null) {
			jComboBox29 = new JComboBox();
			jComboBox29.setBounds(new Rectangle(305, 165, 50, 20));
			for(int i=0;i<MainMemory.MAXPAGES;i++) {
				jComboBox29.addItem(Integer.toString(i));
			}
		}
		return jComboBox29;
	}

	/**
	 * This method initializes jComboBox210	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	private JComboBox getJComboBox210() {
		if (jComboBox210 == null) {
			jComboBox210 = new JComboBox();
			jComboBox210.setBounds(new Rectangle(360, 165, 50, 20));
			for(int i=0;i<MainMemory.MAXPAGES;i++) {
				jComboBox210.addItem(Integer.toString(i));
			}
		}
		return jComboBox210;
	}

	/**
	 * This method initializes jComboBox211	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	private JComboBox getJComboBox211() {
		if (jComboBox211 == null) {
			jComboBox211 = new JComboBox();
			jComboBox211.setBounds(new Rectangle(415, 165, 50, 20));
			for(int i=0;i<MainMemory.MAXPAGES;i++) {
				jComboBox211.addItem(Integer.toString(i));
			}
		}
		return jComboBox211;
	}

	/**
	 * This method initializes jButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButton() {
		if (jButton == null) {
			jButton = new JButton();
			
			jButton.setBounds(new Rectangle(21, 136, 210, 43));
			jButton.addMouseListener(new java.awt.event.MouseAdapter() {
				public void mouseClicked(java.awt.event.MouseEvent e) {
					jComboBox2.setSelectedIndex((int) Math.round(Math.random()*(MainMemory.MAXPAGES-1)));
					jComboBox21.setSelectedIndex((int) Math.round(Math.random()*(MainMemory.MAXPAGES-1)));
					jComboBox22.setSelectedIndex((int) Math.round(Math.random()*(MainMemory.MAXPAGES-1)));
					jComboBox23.setSelectedIndex((int) Math.round(Math.random()*(MainMemory.MAXPAGES-1)));
					jComboBox24.setSelectedIndex((int) Math.round(Math.random()*(MainMemory.MAXPAGES-1)));
					jComboBox25.setSelectedIndex((int) Math.round(Math.random()*(MainMemory.MAXPAGES-1)));
					jComboBox26.setSelectedIndex((int) Math.round(Math.random()*(MainMemory.MAXPAGES-1)));
					jComboBox27.setSelectedIndex((int) Math.round(Math.random()*(MainMemory.MAXPAGES-1)));
					jComboBox28.setSelectedIndex((int) Math.round(Math.random()*(MainMemory.MAXPAGES-1)));
					jComboBox29.setSelectedIndex((int) Math.round(Math.random()*(MainMemory.MAXPAGES-1)));
					jComboBox210.setSelectedIndex((int) Math.round(Math.random()*(MainMemory.MAXPAGES-1)));
					jComboBox211.setSelectedIndex((int) Math.round(Math.random()*(MainMemory.MAXPAGES-1)));
				}
			});
		}
		return jButton;
	}

	/**
	 * This method initializes jButton1	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButton1() {
		if (jButton1 == null) {
			jButton1 = new JButton();
			jButton1.setBounds(new Rectangle(169, 198, 123, 28));

			
			jButton1.addMouseListener(new java.awt.event.MouseAdapter() {
				public void mouseClicked(java.awt.event.MouseEvent e) {
					OrriSek[0]=Integer.parseInt(getJComboBox2().getItemAt(getJComboBox2().getSelectedIndex()).toString());
					OrriSek[1]=Integer.parseInt(getJComboBox21().getItemAt(getJComboBox21().getSelectedIndex()).toString());
					OrriSek[2]=Integer.parseInt(getJComboBox22().getItemAt(getJComboBox22().getSelectedIndex()).toString());
					OrriSek[3]=Integer.parseInt(getJComboBox23().getItemAt(getJComboBox23().getSelectedIndex()).toString());
					OrriSek[4]=Integer.parseInt(getJComboBox24().getItemAt(getJComboBox24().getSelectedIndex()).toString());
					OrriSek[5]=Integer.parseInt(getJComboBox25().getItemAt(getJComboBox25().getSelectedIndex()).toString());
					OrriSek[6]=Integer.parseInt(getJComboBox26().getItemAt(getJComboBox26().getSelectedIndex()).toString());
					OrriSek[7]=Integer.parseInt(getJComboBox27().getItemAt(getJComboBox27().getSelectedIndex()).toString());
					OrriSek[8]=Integer.parseInt(getJComboBox28().getItemAt(getJComboBox28().getSelectedIndex()).toString());
					OrriSek[9]=Integer.parseInt(getJComboBox29().getItemAt(getJComboBox29().getSelectedIndex()).toString());
					OrriSek[10]=Integer.parseInt(getJComboBox210().getItemAt(getJComboBox210().getSelectedIndex()).toString());
					OrriSek[11]=Integer.parseInt(getJComboBox211().getItemAt(getJComboBox211().getSelectedIndex()).toString());

					OrriOrdezkapenPolitikaFrame frameOOP = new OrriOrdezkapenPolitikaFrame(getJComboBoxPolicies().getSelectedIndex(),getJComboBox1().getSelectedIndex()+2,OrriSek,"languages/" + xmlLanguageFile);
					frameOOP.center(frameOOP);
					frameOOP.setVisible(true);
				}
			});
		}
		return jButton1;
	}

	private void center() {
        GraphicsEnvironment ge = GraphicsEnvironment.getLocalGraphicsEnvironment();
        Point center = ge.getCenterPoint();
        Rectangle bounds = ge.getMaximumWindowBounds();
        int w = 490;
        int h = 284;
        int x = center.x - w/2, y = center.y - h/2;
        frameBegin.setBounds(x, y, w, h);
        if (w == bounds.width && h == bounds.height)
        	frameBegin.setExtendedState(Frame.MAXIMIZED_BOTH);
        frameBegin.validate();
    }

	public static void main (String[] args) throws ParserConfigurationException, SAXException, IOException {
		frameBegin = new DatuakHasieratuFrame();
		frameBegin.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frameBegin.center();
		frameBegin.setVisible(true);
	}

}  //  @jve:decl-index=0:visual-constraint="103,16"
