package proiektua;

class MainMemory {
	// http://en.wikipedia.org/wiki/Cache_algorithms
	private ReplacementPolicyInterface RP;
	private PageTable PT;
	public static final int MAXPAGES=8;

	public MainMemory(int policy, int frameAmount,int pageSec[]) {
		PT = new PageTable(frameAmount);
		switch (policy) {
		case 0:
			RP = new ReplacementPolicyOptimal(frameAmount,pageSec);
			break;
		case 1:
			RP = new ReplacementPolicyFIFO(frameAmount);
			break;
		case 2: 
			RP = new ReplacementPolicyLRU(frameAmount);
			break;
		}
	}

	public void initialize() {
		PT.initialize();
		RP.initialize();
		
	}
	public ReplacementPolicyInterface getRP() {
		return RP;
	}

	public void setRP(ReplacementPolicyInterface rp) {
		RP = rp;
	}
	
	public PageFault addPage(int page) {
		PageFault pf = RP.addPage(page);
		PT.addPage(pf,page);
		return pf;
	}
	
	public PageTable getPT() {
		return PT;
	}
}