package proiektua;


import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Font;
import java.awt.Frame;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.GraphicsEnvironment;
import java.awt.Point;
import java.awt.Polygon;

import javax.swing.BorderFactory; 
import javax.swing.ImageIcon;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JFrame;
import javax.swing.JDesktopPane;
import javax.swing.JButton;

import java.awt.Rectangle;
import java.awt.font.TextAttribute;
import java.io.IOException;
import java.util.Map;

import javax.swing.JLabel;
import javax.swing.JTable;
import javax.swing.table.*;
import javax.xml.parsers.ParserConfigurationException;

import org.xml.sax.SAXException;

public class OrriOrdezkapenPolitikaFrame extends JFrame {

	private static final long serialVersionUID = 1L;
	private static OrriOrdezkapenPolitikaFrame frame = null;
	private JPanel jContentPane = null;
	private JDesktopPane jDesktopPane = null;
	private JButton jButtonNext = null;
	private JButton jButtonPrevious = null;
	
	private int jTableRowHeight = 20;
	private Font jTableFont = new Font("Dialog",Font.BOLD,16);  //  @jve:decl-index=0:

	private JTable jTableAP = null; // AP = Actual Page
	private MyTableModel dataModelAP; // model for jTableAP
	
	private JTable jTableRP = null; // RA = Replacement Policy
	private MyTableModel dataModelRP; // model for jTableRP
	
	private JTable jTableVM = null; // VM = Virtual Memoria
	private MyTableModel dataModelVM; // model for jTableVM
	
	private JTable jTablePT = null; // PT = Page Table
	private MyTableModel dataModelPT; // model for jTablePT
	
	private JTable jTableMM = null; // MM = Main Memory
	private MyTableModel dataModelMM; // model for jTableMM
	
	private JTable jTableSwap = null;
	private MyTableModel dataModelSwap;// model for jTableSwap
	
	private JLabel jLabelPageSecuence = null;
	private JLabel jLabelPolicy = null;
	private JLabel jLabelPTLogAddress = null;
	private JLabel jLabelPTFisAddress = null;
	private JLabel jLabelPTLoadBit = null;
	private JLabel jLabelPTTitle = null;
	private JLabel jLabelVM = null;
	private JLabel jLabelMM = null;
	private JLabel jLabelSwap = null;
	private JLabel jLabelOS = null; 
	private JLabel jLabelOSText = null; // OS = Operative Sistem
	private JLabel jLabelPageIn = null;
	private JLabel jLabelPageOut = null;
	private JLabel jLabelNewestPage = null;
	private JLabel jLabelOldestPage = null;
	
	private int policy;
	private int OrriSek[];
	private MainMemory MM;

	private int nextLoadingPage=0;
	private int pageCount;
	
    private int titleBarHeight=20,frameBorderWidth=4;
    
    private String xmlFile = null;
    private String pageName = null;
	
	/**
	 * This is the default constructor
	 */
	public OrriOrdezkapenPolitikaFrame() {
		super();
		initialize();
	}
	private int Max(int t[]) {
		int maximum = t[0];   // start with the first value
	    for (int i=1; i<t.length; i++) {
	        if (t[i] > maximum) {
	            maximum = t[i];   // new maximum
	        }
	    }
	    return maximum+1;		
	}
	public OrriOrdezkapenPolitikaFrame(int pol, int marKop, int pageSec[], String xmlF) {
		super();
		/* Probak egiteko pol=1 jarriko dugu FIFO politika egikaritua dagoelako */
		//pol=1;
		xmlFile = xmlF;
		OrriSek = pageSec;
		pageCount = Max(pageSec);
		policy = pol;
		MM = new MainMemory(pol,marKop,pageSec);
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(700, 600);
		this.setContentPane(getJContentPane());
		//this.setTitle("Orri Ordezkapen Politika");
		//System.out.println(OrriSek[0]);
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(new BorderLayout());
			jContentPane.add(getJDesktopPane(), BorderLayout.CENTER);

		}
		return jContentPane;
	}

	/**
	 * This method initializes jDesktopPane	
	 * 	
	 * @return javax.swing.JDesktopPane	
	 */
	private JDesktopPane getJDesktopPane() {
		if (jDesktopPane == null) {
			Map map = new JLabel().getFont().getAttributes();
            map.put(TextAttribute.UNDERLINE, TextAttribute.UNDERLINE_ON);
            Font underLineFont = new Font(map);
            
            jLabelPageSecuence = new JLabel();
			jLabelPolicy = new JLabel();
			jLabelOS = new JLabel();
			//this.setHorizontalAlignment(CENTER);
			jLabelOSText = new JLabel();
			jLabelSwap = new JLabel();
			jLabelSwap.setFont(underLineFont);
			jLabelSwap.setHorizontalAlignment(JLabel.CENTER);
			//jLabelSwap.setBorder(BorderFactory.createLineBorder(Color.black));
			
			jLabelMM = new JLabel();
			jLabelMM.setFont(underLineFont);
			jLabelMM.setHorizontalAlignment(JLabel.CENTER);
			//jLabelMM.setBorder(BorderFactory.createLineBorder(Color.black));
			
			jLabelVM = new JLabel();
			jLabelVM.setFont(underLineFont);
			jLabelVM.setHorizontalAlignment(JLabel.CENTER);
			//jLabelVM.setBorder(BorderFactory.createLineBorder(Color.black));
			
			jLabelPTTitle = new JLabel();
            jLabelPTTitle.setFont(underLineFont);
            jLabelPTTitle.setHorizontalAlignment(JLabel.CENTER);
            //jLabelPTTitle.setBorder(BorderFactory.createLineBorder(Color.black));
            
			jLabelPTLogAddress = new JLabel();
			jLabelPTLogAddress.setFont(new Font("Times",Font.BOLD,10));
			
			jLabelPTFisAddress = new JLabel();
			jLabelPTFisAddress.setFont(new Font("Times",Font.BOLD,10));
			
			jLabelPTLoadBit = new JLabel();
			jLabelPTLoadBit.setFont(new Font("Times",Font.BOLD,10));
			
			jLabelPageIn = new JLabel();
			jLabelPageIn.setBorder(BorderFactory.createLineBorder(Color.black));
			jLabelPageIn.setHorizontalAlignment(JLabel.CENTER);
			jLabelPageIn.setOpaque(true);
			
			jLabelPageOut = new JLabel();
			jLabelPageOut.setBorder(BorderFactory.createLineBorder(Color.black));
			jLabelPageOut.setHorizontalAlignment(JLabel.CENTER);
			jLabelPageOut.setOpaque(true);
			
			jLabelNewestPage = new JLabel();
			jLabelNewestPage.setHorizontalAlignment(JLabel.RIGHT);
			jLabelNewestPage.setFont(underLineFont);
			
			jLabelOldestPage = new JLabel();
			jLabelOldestPage.setHorizontalAlignment(JLabel.RIGHT);
			jLabelOldestPage.setFont(underLineFont);
			
			
			jDesktopPane = new JDesktopPane();
			jDesktopPane.add(getJButtonNext(), null);
			jDesktopPane.add(getJButtonPrevious(), null);
			jDesktopPane.add(jLabelPageSecuence, null);
			jDesktopPane.add(jLabelPolicy, null);
			jDesktopPane.add(jLabelPTLogAddress, null);
			jDesktopPane.add(jLabelPTFisAddress, null);
			jDesktopPane.add(jLabelPTLoadBit, null);
			jDesktopPane.add(jLabelPTTitle, null);
			jDesktopPane.add(jLabelVM, null);
			jDesktopPane.add(jLabelMM, null);
			jDesktopPane.add(jLabelSwap, null);
			jDesktopPane.add(jLabelOS, null);
			jDesktopPane.add(jLabelOSText, null);
			jDesktopPane.add(jLabelPageIn, null);
			jDesktopPane.add(jLabelPageOut, null);
			jDesktopPane.add(jLabelNewestPage, null);
			jDesktopPane.add(jLabelOldestPage, null);
			jDesktopPane.add(getJTableActualPage(), null);
			jDesktopPane.add(getJTableReplacementPolicy(), null);
			jDesktopPane.add(getJTableVirtualMemoria(), null);
			jDesktopPane.add(getJTablePageTable(), null);
			jDesktopPane.add(getJTableMainMemory(), null);
			jDesktopPane.add(getJTableSwap(), null);
			//jDesktopPane.setLayout(new BorderLayout());
			//jDesktopPane.add(jTableAM.getTableHeader(), BorderLayout.PAGE_START);
			//jDesktopPane.add(jTableAM, BorderLayout.CENTER);
			setLabelTextPosition();
		}
		return jDesktopPane;
	}
	
	public void printError(String error) {
		JOptionPane.showMessageDialog(this,
			    error,
			    "Error",
			    JOptionPane.ERROR_MESSAGE);
	}
	
	private void setLabelTextPosition() {
		String aux;
		ReadXML xmlConfig = null;
		try {
			xmlConfig = new ReadXML(xmlFile);
		

			aux = xmlConfig.getSectionNodeValue("labels","pageReplamentPolicy") + " ";
			switch(policy) {
				case 0: aux = aux + xmlConfig.getSectionNodeValue("configurationOptions","policyOptimum");
					break;
				case 1: aux = aux + xmlConfig.getSectionNodeValue("configurationOptions","policyFIFO");
					break;
				case 2: aux = aux + xmlConfig.getSectionNodeValue("configurationOptions","policyLRU");
					break;
			}
			
			
			jLabelPolicy.setText(aux);
			jLabelPolicy.setBounds(new Rectangle(jTableRP.getBounds().x, jTableRP.getBounds().y-60, aux.length()*8, 20));

			aux=xmlConfig.getSectionNodeValue("labels","pageSecuence");
			jLabelPageSecuence.setText(aux);
			jLabelPageSecuence.setBounds(new Rectangle(jTableRP.getBounds().x, jTableRP.getBounds().y-30, aux.length()*8, 20));
			jTableAP.setBounds(new Rectangle(jLabelPageSecuence.getBounds().x + jLabelPageSecuence.getBounds().width, 50, 15*12, jTableRowHeight));
			
			int height;
			if(jTablePT.getBounds().y + jTablePT.getBounds().height > jTableMM.getBounds().y + jTableMM.getBounds().height) {
				height=jTablePT.getBounds().y + jTablePT.getBounds().height;
			} else {
				height=jTableMM.getBounds().y + jTableMM.getBounds().height;
			}
			jLabelOS.setBounds(new Rectangle(jTablePT.getBounds().x + jTablePT.getBounds().width + ((jTableMM.getBounds().x - 40 - (jTablePT.getBounds().width + jTablePT.getBounds().x))/3), height + 10, 97, 71));
			try {
				//JAR-ean kargatzeko imagiÃ±ak, modu honetan kargatu behar dira:
				jLabelOS.setIcon(new ImageIcon(getClass().getResource("/images/empty-cloud.gif")));
			} catch (Exception e) {
				// Eclipse-n kargatzeko imagiÃ±ak, modu honetan kargatu behar dira:
				jLabelOS.setIcon(new ImageIcon("/home/pron/empty-cloud.gif"));
				
			}
			
			aux=xmlConfig.getSectionNodeValue("labels","os");
			jLabelOSText.setText(aux);
			jLabelOSText.setBounds(new Rectangle(jLabelOS.getBounds().x + (jLabelOS.getBounds().width/2) - aux.length()*10/2,jLabelOS.getBounds().y + (jLabelOS.getBounds().height/2) - 10, aux.length()*10, 20));

			aux=xmlConfig.getSectionNodeValue("labels","swap");
			jLabelSwap.setText(aux);
			jLabelSwap.setBounds(new Rectangle(jTableSwap.getBounds().x, jTableSwap.getBounds().y-20, jTableSwap.getBounds().width, 20));

			aux=xmlConfig.getSectionNodeValue("labels","mainMemory");
			jLabelMM.setText(aux);
			jLabelMM.setBounds(new Rectangle(jTableMM.getBounds().x - (300 - jTableMM.getBounds().width)/2, jTableMM.getBounds().y - 30, 300, 20));
			
			aux=xmlConfig.getSectionNodeValue("labels","virtualMemory");
			jLabelVM.setText(aux);
			jLabelVM.setBounds(new Rectangle(jTableVM.getBounds().x - (140 - jTableVM.getBounds().width)/2, jTableVM.getBounds().y - 30, 140, 20));

			aux=xmlConfig.getSectionNodeValue("labels","pageTable");
			jLabelPTTitle.setText(aux);
			jLabelPTTitle.setBounds(new Rectangle(jTablePT.getBounds().x - (230 - jTablePT.getBounds().width)/2, jTablePT.getBounds().y - 38,  230, 20));

			aux=xmlConfig.getSectionNodeValue("labels","logAddress");
			jLabelPTLogAddress.setText(aux);
			jLabelPTLogAddress.setBounds(new Rectangle(jTablePT.getBounds().x, jTablePT.getBounds().y - 15, 30, 15));

			aux=xmlConfig.getSectionNodeValue("labels","fisAddress");
			jLabelPTFisAddress.setText(aux);
			jLabelPTFisAddress.setBounds(new Rectangle(jTablePT.getBounds().x + 30, jTablePT.getBounds().y - 15, 30, 15));

			aux=xmlConfig.getSectionNodeValue("labels","loadBit");
			jLabelPTLoadBit.setText(aux);
			jLabelPTLoadBit.setBounds(new Rectangle(jTablePT.getBounds().x + 60, jTablePT.getBounds().y - 15, 10, 15));

			//
			jLabelPageIn.setText("IN");
			jLabelPageIn.setBounds(new Rectangle(jTableMM.getBounds().x +jTableMM.getBounds().width + (jTableSwap.getBounds().x - (jTableMM.getBounds().x +jTableMM.getBounds().width))/2 - 20 , jTableMM.getBounds().y - 10, 15, 15));

			jLabelPageOut.setText("OUT");
			jLabelPageOut.setBounds(new Rectangle(jTableMM.getBounds().x +jTableMM.getBounds().width + (jTableSwap.getBounds().x - (jTableMM.getBounds().x +jTableMM.getBounds().width))/2 - 25 , jTableMM.getBounds().y + 40, 35, 15));

			aux=xmlConfig.getSectionNodeValue("labels","oldestPage");
			jLabelOldestPage.setText(aux);
			jLabelOldestPage.setBounds(new Rectangle(frameBorderWidth, jTableRP.getBounds().y, jTableRP.getBounds().x - frameBorderWidth - 5, 15));
			
			aux=xmlConfig.getSectionNodeValue("labels","newestPage");
			jLabelNewestPage.setText(aux);
			jLabelNewestPage.setBounds(new Rectangle(frameBorderWidth, jTableRP.getBounds().y + jTableRP.getBounds().height - 2*jTableRowHeight , jTableRP.getBounds().x - frameBorderWidth - 5, 15));
			
			
			
			pageName=xmlConfig.getSectionNodeValue("labels","pageName");			
			
			for(int i=1;i<=pageCount;i++) {
				dataModelVM.setValueAt(pageName+(i-1), i, 0);
			}
			
			for(int i=0;i<dataModelSwap.getRowCount();i++) {
				dataModelSwap.setValueAt(pageName+i, i, 0);
			}

			aux = xmlConfig.getSectionNodeValue("titles","policyFrame");
			this.setTitle(aux);
			
			aux = xmlConfig.getSectionNodeValue("buttons","nextStep");
			jButtonNext.setText(aux);
			
			aux = xmlConfig.getSectionNodeValue("buttons","previousStep");
			jButtonPrevious.setText(aux);
			
		} catch (NullPointerException e) {
			printError(xmlFile+": "+e.getMessage());
		} catch (ParserConfigurationException e) {
			printError(xmlFile+": "+e.getMessage());
		} catch (SAXException e) {
			printError(xmlFile+": "+e.getMessage());
		} catch (IOException e) {
			printError(xmlFile+": "+e.getMessage());
		}
	}
	private void drawArrow(int x1, int y1,int x2,int y2,Graphics2D g2d, int arrowWay)
	{
		 int x[]={0,5,0};
	     int y[]={-5,0,5};
		switch(arrowWay) {
		//right
		case 0: // nothing to do
	     		break;
	    //left
		case 1: x[1]=-5;
 				break;
 		// down		
		case 2:	x[0]=-5;
 				y[0]=0;
 				break;
 		// up
		case 3: x[2]=-5;
 				y[2]=0;
		}
	     g2d.drawLine(x1,y1,x2,y2);
	     g2d.translate(x2,y2);
	     g2d.fillPolygon(new Polygon(x,y,3));
	     g2d.translate(-x2,-y2);
	}

	public void paint(Graphics g){
        super.paint(g);
        int xStart,yStart,xEnd,yEnd;
        int ovalWidth=jTableSwap.getBounds().width + 20,ovalHeight=20;
        // swap ovals and lines
        xStart = jTableSwap.getBounds().x + frameBorderWidth -10;
        yStart= jTableSwap.getBounds().y - 20;
        g.drawOval(xStart, yStart, ovalWidth, ovalHeight);
        
        xEnd=xStart;
        yEnd=jTableSwap.getBounds().y + jTableSwap.getBounds().height + titleBarHeight + 20;
        g.drawOval(xEnd, yEnd, ovalWidth, ovalHeight);
        
        //xStart=xStart;
        yStart=yStart +ovalHeight/2 ;
        xEnd=xStart;
        yEnd=yEnd + ovalHeight/2;
        g.drawLine(xStart, yStart, xEnd, yEnd);
        
        xStart=xStart+ovalWidth;
        //yStart=yStart;
        xEnd=xEnd+ovalWidth;
        //yEnd=yEnd;
        g.drawLine(xStart, yStart, xEnd, yEnd);
        
        paintFromMMtoSwap(g,null);
        paintFromSwaptoMM(g,null);
        
        // from jTableVM to jTablePT 
        xStart=jTableVM.getBounds().x + jTableVM.getBounds().width + frameBorderWidth ;
        yStart=jTableVM.getBounds().y + jTableVM.getBounds().height/2+titleBarHeight;
        xEnd=xStart + (jTablePT.getBounds().x - xStart)/2 ;
        yEnd=yStart;
        g.drawLine(xStart, yStart, xEnd, yEnd);
        
        xStart=xEnd;
        //yStart=yStart;
        //xEnd=xEnd;
        yEnd=jTablePT.getBounds().y+titleBarHeight+5;
        g.drawLine(xStart, yStart, xEnd, yEnd);
        
        //xStart=xStart;
        yStart=yEnd;
        xEnd=jTablePT.getBounds().x;
        //yEnd=yEnd;
        drawArrow(xStart,yStart, xEnd, yEnd,(Graphics2D) g,0);
        
        // from jTablePT to jLabelOS
        xStart=jTablePT.getBounds().x + jTablePT.getBounds().width-5;
        yStart=jTablePT.getBounds().y + jTablePT.getBounds().height+titleBarHeight;
        xEnd=xStart;
        yEnd=titleBarHeight+jLabelOS.getBounds().y + jLabelOS.getBounds().height/2;
        g.drawLine(xStart,yStart, xEnd, yEnd);
        
        xStart=xEnd;
        yStart=yEnd;
        xEnd=jLabelOS.getBounds().x;
        //yEnd=yEnd;
        drawArrow(xStart,yStart, xEnd, yEnd,(Graphics2D) g,0);
        
        
        // from jLabelOS to jTableMM
        xStart=xEnd+jLabelOS.getBounds().width+frameBorderWidth;
        //yStart=yStart;
        xEnd=jTableMM.getBounds().x + jTableMM.getBounds().width/2+frameBorderWidth;
        //yEnd=yEnd;
        g.drawLine(xStart,yStart, xEnd, yEnd);
        //g.setColor(Color.blue);
        
        xStart=xEnd;
        //yStart=yStart;
        //xEnd=xEnd;
        yEnd=jTableMM.getBounds().y+jTableMM.getBounds().height + titleBarHeight + 5;
        drawArrow(xStart,yStart, xEnd, yEnd,(Graphics2D) g,3);
	}
	
	
	private void paintFromMMtoSwap(Graphics g, Color c) {
		int xStart,yStart,xEnd,yEnd;
		if(c==null) {
			g.setColor(Color.BLACK);
		} else {
			g.setColor(c);
		}
		g.setColor(c);
		xStart=jTableMM.getBounds().x +jTableMM.getBounds().width +frameBorderWidth;
        yStart=jTableSwap.getBounds().y + titleBarHeight + 30;
        xEnd=jTableSwap.getBounds().x ;
        yEnd=yStart;
        drawArrow(xStart, yStart, xEnd, yEnd,(Graphics2D) g,0);
        
        g.setColor(Color.black);
	}
	
	private void paintFromSwaptoMM(Graphics g, Color c) {
		int xStart,yStart,xEnd,yEnd;
		if(c==null) {
			g.setColor(Color.BLACK);
		} else {
			g.setColor(c);
		}
		g.setColor(c);
		xStart=jTableSwap.getBounds().x + frameBorderWidth ;
        yStart=jTableSwap.getBounds().y + titleBarHeight + 10;
        xEnd=jTableMM.getBounds().x +jTableMM.getBounds().width +frameBorderWidth + 5 ;
        yEnd=yStart;
        drawArrow(xStart, yStart, xEnd, yEnd,(Graphics2D) g,1);
        
        g.setColor(Color.black);
	}

	/**
	 * This method initializes jButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButtonNext() {
		if (jButtonNext == null) {
			jButtonNext = new JButton();
			jButtonNext.setBounds(new Rectangle(150, 220, 162, 40));
			jButtonNext.addMouseListener(new java.awt.event.MouseAdapter() {
				public void mouseClicked(java.awt.event.MouseEvent e) {
					if(jButtonNext.isEnabled()) {
						paint(getGraphics());
					}
					PageFault pageFault;
					if(nextLoadingPage<12){
						//OrriHutsegitea=MN.addOrria(OrriSek[UnekoOrria]);
						pageFault=MM.addPage(OrriSek[nextLoadingPage]);
						//System.out.println("last loaded page index: "+(nextLoadingPage));
						updateJTable(pageFault);
						nextLoadingPage++;
						if(nextLoadingPage>11) {
							jButtonNext.setEnabled(false);							
						} else {
							jButtonNext.setEnabled(true);
						}
						if(nextLoadingPage>0) {
							jButtonPrevious.setEnabled(true);
						} else {
							jButtonPrevious.setEnabled(false);
						}
					} else {
						jButtonNext.setEnabled(false);
					}
				}
			});
		}
		return jButtonNext;
	}
	
	private JButton getJButtonPrevious() {
		if (jButtonPrevious == null) {
			jButtonPrevious = new JButton();
			jButtonPrevious.setBounds(new Rectangle(350, 220, 162, 40));
			jButtonPrevious.setEnabled(false);
			//jButtonPrevious.setText("Aurrekoa");
			jButtonPrevious.addMouseListener(new java.awt.event.MouseAdapter() {
				public void mouseClicked(java.awt.event.MouseEvent e) {
					if(jButtonPrevious.isEnabled()) {	
						paint(getGraphics());
					}
					PageFault pageFault = null;
					if(nextLoadingPage>0){
						//OrriHutsegitea=MN.addOrria(OrriSek[UnekoOrria]);
						nextLoadingPage--;
						MM.initialize();
						cleanTableForPrevious();
						
						for(int i=0;i<nextLoadingPage; i++) {
							pageFault = MM.addPage(OrriSek[i]);
						}
						//System.out.println("last loaded page index: "+(nextLoadingPage-1));
						if(nextLoadingPage>0) {
							nextLoadingPage--;
							updateJTable(pageFault);
							nextLoadingPage++;
						}
						if(nextLoadingPage<1) {
							jButtonNext.setEnabled(true);	
							jButtonPrevious.setEnabled(false);							
						} else {
							jButtonNext.setEnabled(true);	
							jButtonPrevious.setEnabled(true);	
						}
					} else {
						jButtonPrevious.setEnabled(false);
						//System.out.println("Ez dago orririk kargatzeko");
					}
				}
			});
		}
		return jButtonPrevious;
	}

	private void cleanTableForPrevious() {
		for(int i=0;i<MM.getRP().getFrameAmount();i++) {
			dataModelRP.setValueAt("", MM.getRP().getFrameAmount()-i-1, nextLoadingPage);		
		}
		dataModelRP.setValueAt(null, MM.getRP().getFrameAmount(), nextLoadingPage);
		if(nextLoadingPage<12) {
			TextAndBackgroundColor tabcOld= new TextAndBackgroundColor(Integer.toString(OrriSek[nextLoadingPage]),Color.white);
			dataModelAP.setValueAt(tabcOld, 0, nextLoadingPage);
		}
		for(int i=0;i<dataModelMM.getRowCount();i++) {
			dataModelMM.setValueAt("-", i, 0);
		}
		
		for(int i=0;i<dataModelPT.getRowCount();i++) {
			dataModelPT.setValueAt(i, i, 0);
			dataModelPT.setValueAt("-", i, 1);
			dataModelPT.setValueAt(0, i, 2);
		}
		
		for(int i=0;i<dataModelSwap.getRowCount();i++) {
			dataModelSwap.setValueAt(pageName+i, i, 0);
		}
		jLabelPageIn.setBackground(Color.white);
	
		jLabelPageOut.setBackground(Color.white);
		
	}
	
	private void updateJTable(PageFault pf) {
		
		String page = new String();
		
		// UPDATE jTableRP			
		for(int i=0;i<MM.getRP().getFrameAmount();i++) {
			page = (MM.getRP().getPage(i) !=  -1) ? String.valueOf(MM.getRP().getPage(i)) : "";
			dataModelRP.setValueAt(page, MM.getRP().getFrameAmount()-i-1, nextLoadingPage);		
		}
		
		ImageIcon imageIcon = new ImageIcon();
		try {
			// JAR-ean kargatzeko imagiÃ±ak, modu honetan kargatu behar dira:
			imageIcon = (pf.isPageFault()==true)? new ImageIcon(getClass().getResource("/images/false.gif")) : new ImageIcon(getClass().getResource("/images/true.gif"));
		} catch (Exception e) {
			// Eclipse-n kargatzeko imagiÃ±ak, modu honetan kargatu behar dira:
			imageIcon = (pf.isPageFault()==true)? new ImageIcon("/home/pron/false.gif") : new ImageIcon("/home/pron/true.gif");

		}
		dataModelRP.setValueAt(imageIcon, MM.getRP().getFrameAmount(), nextLoadingPage);
		// UPDATE jTableAP
		TextAndBackgroundColor tabcNew= new TextAndBackgroundColor(Integer.toString(OrriSek[nextLoadingPage]),Color.black,Color.white);

		if(nextLoadingPage>0) {
			TextAndBackgroundColor tabcOld= new TextAndBackgroundColor(Integer.toString(OrriSek[nextLoadingPage-1]),Color.white);
			dataModelAP.setValueAt(tabcOld, 0, nextLoadingPage-1);
		}
		dataModelAP.setValueAt(tabcNew, 0, nextLoadingPage);
		/*if(loadedPageAmount<12) {
			TextAndBackgroundColor tabcOld= new TextAndBackgroundColor(Integer.toString(OrriSek[loadedPageAmount+1]),Color.white);
			dataModelAP.setValueAt(tabcOld, 0, loadedPageAmount+1);
		}*/

		// UPDATE jTablePT, jTableMM, jTableSwap
		int fisicAddress;
		int loadStatus;
		Color normal = Color.WHITE;
		Color fault = Color.RED; 
		Color hit = Color.GREEN; 
		
		// For swap and page table usage
		Color out = Color.RED; // out from swap
		Color in = new Color(171,130,255); // in to swap
		
		TextAndBackgroundColor valuePT;
		TextAndBackgroundColor valueMM;
		boolean swapPageOut=false,swapPageIn=false;
	
		for(int logicalAddress=0;logicalAddress<pageCount;logicalAddress++) {
			fisicAddress = MM.getPT().getFisicAddress(logicalAddress);
			if(fisicAddress==-1){
				valuePT = new TextAndBackgroundColor("-",normal);
				valueMM = new TextAndBackgroundColor(pageName+logicalAddress,normal);
			} else {
				if(pf.isPageFault() && logicalAddress==OrriSek[nextLoadingPage]) {
					valuePT = new TextAndBackgroundColor(Integer.toString(fisicAddress),fault);
					valueMM = new TextAndBackgroundColor(pageName+logicalAddress,fault);
				} else {
					if(!pf.isPageFault() && logicalAddress==OrriSek[nextLoadingPage]) {
						valuePT = new TextAndBackgroundColor(Integer.toString(fisicAddress),hit);
						valueMM = new TextAndBackgroundColor(pageName+logicalAddress,hit);
					} else {
						valuePT = new TextAndBackgroundColor(Integer.toString(fisicAddress),normal);
						valueMM = new TextAndBackgroundColor(pageName+logicalAddress,normal);
					}
				}
				dataModelMM.setValueAt(valueMM,fisicAddress,0);
				
			}
			
			if(logicalAddress == pf.getOutPage() && pf.isPageFault()) {
				valuePT = new TextAndBackgroundColor("-",in);
			}
			dataModelPT.setValueAt(new TextAndBackgroundColor(Integer.toString(logicalAddress),valuePT.getColor()),logicalAddress,0);
			dataModelPT.setValueAt(valuePT,logicalAddress,1);
			dataModelPT.setValueAt(new TextAndBackgroundColor(Integer.toString(MM.getPT().getFisicAddressLoadStatus(logicalAddress)),valuePT.getColor()),logicalAddress,2);
			
			//dataModelPT.setValueAt(logicalAddress,logicalAddress,0);
			

			TextAndBackgroundColor valueSwap;
			loadStatus = MM.getPT().getFisicAddressLoadStatus(logicalAddress);
			//dataModelPT.setValueAt(loadStatus,logicalAddress,2);

			
			if(loadStatus==0) {
				if(pf.getOutPage()==logicalAddress) {
					swapPageIn=true;
					valueSwap = new TextAndBackgroundColor(pageName+logicalAddress,in);
					paintFromMMtoSwap(getGraphics(),in);
					jLabelPageOut.setBackground(in);
				} else {
					valueSwap = new TextAndBackgroundColor(pageName+logicalAddress,normal);
				}
				dataModelSwap.setValueAt(valueSwap,logicalAddress,0);
			} else {
				if(logicalAddress==OrriSek[nextLoadingPage] && pf.isPageFault()) {
					swapPageOut=true;
					valueSwap = new TextAndBackgroundColor("-",out);
					jLabelPageIn.setBackground(out);
					paintFromSwaptoMM(getGraphics(),out);
				} else {
					valueSwap = new TextAndBackgroundColor("-",normal);
				}
				dataModelSwap.setValueAt(valueSwap,logicalAddress,0);
			}
			if(!swapPageOut){
				paintFromSwaptoMM(getGraphics(),null);
				jLabelPageIn.setBackground(normal);
			} else {
				
			}
			if(!swapPageIn){
				paintFromMMtoSwap(getGraphics(),null);
				jLabelPageOut.setBackground(normal);
			} else {
				
			}

		}
	}

	/**
	 * This method initializes jTable	
	 * 	
	 * @return javax.swing.JTable	
	 */
	private JTable getJTableActualPage() {
		if (jTableAP == null) {
			
			RendererText textRenderer = new RendererText(jTableFont);

			dataModelAP = new MyTableModel(1,12);
			jTableAP = new JTable(dataModelAP);
			jTableAP.setRowHeight(jTableRowHeight);

			for(int i=0;i<OrriSek.length;i++) {
				jTableAP.getColumnModel().getColumn(i).setCellRenderer(textRenderer);
				dataModelAP.setValueAt(OrriSek[i], 0, i);
			}
			jTableAP.setBorder(BorderFactory.createLineBorder(Color.white));
			jTableAP.setGridColor(Color.white);
		}
		return jTableAP;
	}
	private JTable getJTableReplacementPolicy() {
		if (jTableRP == null) {
			
			final RendererIcon iconRenderer = new RendererIcon();
			final RendererText textRenderer = new RendererText(jTableFont);

			dataModelRP = new MyTableModel(MM.getRP().getFrameAmount()+1,12);
			jTableRP = new JTable(dataModelRP){
				private static final long serialVersionUID = 1L;
				public TableCellRenderer getCellRenderer(int row, int column) {
			        if ((row == MM.getRP().getFrameAmount())) {
			            return iconRenderer;
			        }
			        return textRenderer;
			    }
			};
			jTableRP.setRowHeight(jTableRowHeight);
			jTableRP.setBorder(BorderFactory.createLineBorder(Color.black));
			jTableRP.setBounds(new Rectangle(150, 80, 30*12, jTableRowHeight*(MM.getRP().getFrameAmount()+1)));
		}
		return jTableRP;
	}

	/**
	 * This method initializes jTable1	
	 * 	
	 * @return javax.swing.JTable	
	 */
	private JTable getJTableVirtualMemoria() {
		if (jTableVM == null) {
			
			final RendererText textRenderer = new RendererText(jTableFont);
			dataModelVM = new MyTableModel(pageCount+3,1);
			
			jTableVM = new JTable(dataModelVM);
			jTableVM.setRowHeight(jTableRowHeight);
			jTableVM.getColumnModel().getColumn(0).setCellRenderer(textRenderer);
			
			dataModelVM.setValueAt("...", 0, 0); // hutsunea (polita egiteko)
			dataModelVM.setValueAt("...", pageCount+1, 0);
			
			//model.setValueAt(imageIcon, 3, 0);
			jTableVM.setBorder(BorderFactory.createLineBorder(Color.black));
			jTableVM.setBounds(new Rectangle(30, 300, 80, jTableRowHeight*(dataModelVM.getRowCount())));
		}
		return jTableVM;
	}
	
	
	private JTable getJTablePageTable() {
		if (jTablePT == null) {
			
			//final RendererText textRenderer = new RendererText(new Font("Times",Font.BOLD,8));
			RendererText textRenderer = new RendererText(jTableFont);
			
			dataModelPT = new MyTableModel(pageCount,3);

			jTablePT = new JTable(dataModelPT);
			jTablePT.setRowHeight(jTableRowHeight);
			jTablePT.getColumnModel().getColumn(0).setPreferredWidth(30);
			jTablePT.getColumnModel().getColumn(1).setPreferredWidth(30);
			jTablePT.getColumnModel().getColumn(2).setPreferredWidth(10);
			
			jTablePT.getColumnModel().getColumn(0).setCellRenderer(textRenderer);
			jTablePT.getColumnModel().getColumn(1).setCellRenderer(textRenderer);
			jTablePT.getColumnModel().getColumn(2).setCellRenderer(textRenderer);
					
			for(int i=0;i<dataModelPT.getRowCount();i++) {
				dataModelPT.setValueAt(i, i, 0);
				dataModelPT.setValueAt("-", i, 1);
				dataModelPT.setValueAt(0, i, 2);
			}

			jTablePT.setBorder(BorderFactory.createLineBorder(Color.black));
			jTablePT.setBounds(new Rectangle(200, 325, 70, jTableRowHeight*(dataModelPT.getRowCount())));
		}
		return jTablePT;
	}

	
	
	private JTable getJTableMainMemory() {
		if (jTableMM == null) {
			
			final RendererText textRenderer = new RendererText(jTableFont);
			dataModelMM = new MyTableModel(MM.getRP().getFrameAmount(),1);

			jTableMM = new JTable(dataModelMM);
			jTableMM.setRowHeight(jTableRowHeight);
			jTableMM.getColumnModel().getColumn(0).setCellRenderer(textRenderer);
			
			for(int i=0;i<dataModelMM.getRowCount();i++) {
				dataModelMM.setValueAt("-", i, 0);
			}

			jTableMM.setBorder(BorderFactory.createLineBorder(Color.black));
			jTableMM.setBounds(new Rectangle(350, 300, 80, jTableRowHeight*(dataModelMM.getRowCount())));
		}
		return jTableMM;
	}
	
	private JTable getJTableSwap() {
		if (jTableSwap == null) {
			
			final RendererText textRenderer = new RendererText(jTableFont);
			dataModelSwap = new MyTableModel(pageCount,1);
			jTableSwap = new JTable(dataModelSwap);
			jTableSwap.setRowHeight(jTableRowHeight);
			jTableSwap.getColumnModel().getColumn(0).setCellRenderer(textRenderer);
			jTableSwap.setBorder(BorderFactory.createLineBorder(Color.black));
			jTableSwap.setBounds(new Rectangle(550, 300, 80, jTableRowHeight*(dataModelSwap.getRowCount())));
		}
		return jTableSwap;
	}
	
	public void center(JFrame frame) {
        GraphicsEnvironment ge = GraphicsEnvironment.getLocalGraphicsEnvironment();
        Point center = ge.getCenterPoint();
        Rectangle bounds = ge.getMaximumWindowBounds();
        int w = 700; 
        int h = 600;
        int x = center.x - w/2, y = center.y - h/2;
        frame.setBounds(x, y, w, h);
        if (w == bounds.width && h == bounds.height)
            frame.setExtendedState(Frame.MAXIMIZED_BOTH);
        frame.validate();
    }
	
	public static void main (String[] args) {
		int orriak[]= new int[] {1,2,3,4,1,2,5,1,2,3,4,5};
		frame = new OrriOrdezkapenPolitikaFrame(0,4,orriak,"languages/castellano.xml");
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frame.center(frame);
		frame.setVisible(true);
		
	}
	
	
}  //  @jve:decl-index=0:visual-constraint="4,11"
