package proiektua;


class PageTable {
	// Matrix will have 8 rows (as much as MainMemory.MAXPAGES) and 2 columns
	// The row index is like the page logic address
	// 1 column: page fisic address
	// 2 column: whether the page is loaded in the main memory
	//				1 --> Loaded in the main memory
	//				0 --> Not loaded in the main memory
	private int Matrix[][];
	private int mmFrameAmount; // Main Memory frame amount
	private int usedFrameAmount;
	//private Vector freeFrames;
	
	public PageTable(int mmFrameAmo) {
		mmFrameAmount=mmFrameAmo;
		Matrix = new int[MainMemory.MAXPAGES][2];
		initialize();
	}

	public void initialize() {
		for(int row=0;row<MainMemory.MAXPAGES;row++) {
			Matrix[row][0]=-1;
			Matrix[row][1]=0;
		}
		usedFrameAmount=0;
		
	}
	public void setMatrix(int matrix[][]) {
		Matrix = matrix;
	}

	public int[][] getMatrix() {
		return Matrix;
	}
	
	public void addPage(PageFault pf,int inPage) {
		boolean pageFault=pf.isPageFault();
		int outPage=pf.getOutPage();
		if(pageFault==true) {
			if(outPage!=-1) {
				Matrix[inPage][0]=Matrix[outPage][0];
				Matrix[inPage][1]=1;
				Matrix[outPage][0]=-1;
				Matrix[outPage][1]=0;
			} else {
				if(usedFrameAmount<mmFrameAmount) {
					Matrix[inPage][0]=usedFrameAmount;
					Matrix[inPage][1]=1;
					usedFrameAmount++;
				}
			}
		}
	}
	
	public int getFisicAddress(int logicalAddress) {
		return Matrix[logicalAddress][0];
	}
	
	public int getFisicAddressLoadStatus(int logicalAddress) {
		return Matrix[logicalAddress][1];
	}
}