package proiektua;

import java.awt.Color;
import java.awt.Component;
import java.awt.Font;

import javax.swing.JLabel;
import javax.swing.JTable;
import javax.swing.table.TableCellRenderer;

class RendererText extends JLabel implements TableCellRenderer {
	 /**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private Font fontNormal = null;
	
	public RendererText () {
		super();
		setOpaque(true); //MUST do this for background to show up.

	}
	public RendererText (Font fo) {
		fontNormal=fo;
		setOpaque(true); //MUST do this for background to show up.

	}
	
	public Component getTableCellRendererComponent(
             JTable table, Object obj,
             boolean isSelected, boolean hasFocus,
             int row, int column) {
		if(obj instanceof TextAndBackgroundColor) {
			this.setText(((TextAndBackgroundColor) obj).getStr());
			this.setBackground(((TextAndBackgroundColor) obj).getColor());
			this.setForeground(((TextAndBackgroundColor) obj).getForeground());
		} else {
			if(obj==null) {
				setText("");
	    	} else {
	    		setText((String) obj.toString());
	    	}
			this.setBackground(Color.white);
			this.setForeground(Color.black);
		}
		if(fontNormal != null){
			this.setFont(fontNormal);
		}
		this.setVerticalAlignment(CENTER);
		this.setHorizontalAlignment(CENTER);

		return this;
    }
}