package proiektua;

public class ReplacementPolicyFIFO implements ReplacementPolicyInterface {
	private Page[] FIFO;
	private int mmFrameAmount; // Main Memory frame amount

	public ReplacementPolicyFIFO(int frameAmount) {
		FIFO = new Page[frameAmount];
		mmFrameAmount=frameAmount;
		initialize();
		
	}

	public void initialize() {
		for(int i=0;i<mmFrameAmount;i++) {
			FIFO[i] = new Page(-1);
		}
	}
	public PageFault addPage(int markoa) {
		
		boolean pageFault=true;
		int i=0;
		// Begiratu kargatu nahi den orria memoria nagusian dagoen
		// OrriHutsegitea true bada, kargatu nahi den orria
		// ez dago memoria nagusian.
		// OrriHutsegitea false bada, kargatu nahi den orria
		// memoria nagusian dago, eta ez da ezer egin behar
		while(i<FIFO.length && pageFault==true) {
			if(FIFO[i].getPage()==markoa) {
				pageFault=false;
			}
			i++;
		}
		PageFault pf = new PageFault(pageFault,-1);
		// OrriHutsegitea egon bada,
		// kargatu den azken orria aterako da,
		// eta berria sartuko da.
		//System.out.println(pageFault);
		if(pageFault==true) {
			// markoak eskubirantz desplazatzen dira, marko berriari lekua egiteko
			pf.setOutPage(FIFO[mmFrameAmount-1].getPage());
			for(i=mmFrameAmount-1;i>0;i--) {
				FIFO[i].setPage(FIFO[i-1].getPage());
			}
			// marko berria sartzen da gelditu den hutsunean
			FIFO[0].setPage(markoa);
		}
		return pf;
	}
	
	public void printMN() {
		for(int i=0;i<mmFrameAmount;i++) {
			System.out.println(i+": "+FIFO[i].getPage());
		}
	}
	
	public int getPage(int index) {
		return FIFO[index].getPage();
	}
	
	public int getPageIndex(int frame) {
		boolean find=false;
		int i=0;
		while(i<mmFrameAmount && find==false) {
			if(FIFO[i].getPage()==frame) {
				find=true;
				return i; 
			}
			i++;
		}
		return -1;
	}



	public int getFrameAmount() {
		return mmFrameAmount;
	}



	public void setMarkoKopurua(int markoKopurua) {
		mmFrameAmount = markoKopurua;
	}
}