package proiektua;


public class ReplacementPolicyLRU implements ReplacementPolicyInterface {
	private Page[] STACK;
	private int mmFrameAmount; // Main Memory frame amount

	public ReplacementPolicyLRU(int frameAmount) {
		STACK = new Page[frameAmount];
		mmFrameAmount=frameAmount;
		initialize();
	}

	public void initialize() {
		for(int i=0;i<mmFrameAmount;i++) {
			STACK[i] = new Page(-1);
		}
	}

	public PageFault addPage(int page) {
		
		boolean pageFault=true;
		int victimIndex=0,i;
		
		// Lehendabizi begiratuko degu ea orria STACK-ean dagoen
		while(victimIndex<STACK.length && pageFault==true) {
			if(STACK[victimIndex].getPage()==page) {
				pageFault=false;
			} else {
				victimIndex++;
			}
		}
		PageFault pf = new PageFault(pageFault,-1);
		// Orria aurkitu bada
		if(pageFault==false) {
			pf.setOutPage(STACK[victimIndex].getPage());
		// Orria aurkitu ez bada
		} else {
			pf.setOutPage(STACK[mmFrameAmount-1].getPage());
			victimIndex=mmFrameAmount-1;
		}
		// markoak eskubirantz desplazatzen dira, victimIndex-etik aurrera	
		for(i=victimIndex;i>0;i--) {
			STACK[i].setPage(STACK[i-1].getPage());
		}
		// marko berria sartzen da gelditu den hutsunean
		STACK[0].setPage(page);
		//System.out.println(pf.isPageFault()+":"+pf.getOutPage());
		return pf;
	}
	
	public void printMN() {
		for(int i=0;i<mmFrameAmount;i++) {
			System.out.println(i+": "+STACK[i].getPage());
		}
	}
	
	public int getPage(int index) {
		return STACK[index].getPage();
	}
	
	public int getPageIndex(int frame) {
		boolean find=false;
		int i=0;
		while(i<mmFrameAmount && find==false) {
			if(STACK[i].getPage()==frame) {
				find=true;
				return i; 
			}
			i++;
		}
		return -1;
	}



	public int getFrameAmount() {
		return mmFrameAmount;
	}



	public void setMarkoKopurua(int markoKopurua) {
		mmFrameAmount = markoKopurua;
	}
}