package proiektua;

import java.util.Vector;

public class ReplacementPolicyOptimal implements ReplacementPolicyInterface {
	private Page[] LIST;
	private int pageSecuence[]; 		// The pages that we will use and we'll use to get the optimum result
	private int pageSecuenceIndex=-1;	// The index for pageSecuence[]
	private int mmFrameAmount; 			// Main Memory frame amount

	public ReplacementPolicyOptimal(int frameAmount,int pageSec[]) {
		LIST = new Page[frameAmount];
		pageSecuence=pageSec;
		mmFrameAmount=frameAmount;
		initialize();

	}
	public void initialize() {
		for(int i=0;i<mmFrameAmount;i++) {
			LIST[i] = new Page(-1);
		}
		pageSecuenceIndex=-1;
	}

	public PageFault addPage(int page) {
		
		boolean pageFault=true;
		int pageOut;
		int i=0;
		pageSecuenceIndex++;
		Vector <Page> pages = new Vector<Page>(); 
		while(i<LIST.length) {
			if(LIST[i].getPage()==-1) {
				for(int j=mmFrameAmount-1;j>0;j--) {
					LIST[j].setPage(LIST[j-1].getPage());
				}
				// marko berria sartzen da gelditu den hutsunean
				LIST[0].setPage(page);
				return new PageFault(pageFault,-1);
			}
			if(LIST[i].getPage()==page) {
				return new PageFault(false,-1);
			}
			// we initialize this vector, in case of, we have to use the optimization
			pages.addElement(LIST[i]);
			i++;
		}
		// if we are here, we have to use the optimization to get the outPage
		i=pageSecuenceIndex+1;
		while(pages.size()>1 && i<pageSecuence.length) {
			int j=pages.size()-1;
			while(j>=0) {
				if(pages.get(j).getPage()==pageSecuence[i]){
					pages.remove(j);
					j=0;
				}
				j--;
			}
			i++;
		}
		pageOut=pages.get(0).getPage();
		LIST[getPageIndex(pageOut)].setPage(page);
		return new PageFault(true,pageOut);
	}
	
	public void printMN() {
		for(int i=0;i<mmFrameAmount;i++) {
			System.out.println(i+": "+LIST[i].getPage());
		}
	}
	
	public int getPage(int index) {
		return LIST[index].getPage();
	}
	
	public int getPageIndex(int frame) {
		boolean find=false;
		int i=0;
		while(i<mmFrameAmount && find==false) {
			if(LIST[i].getPage()==frame) {
				find=true;
				return i; 
			}
			i++;
		}
		return -1;
	}



	public int getFrameAmount() {
		return mmFrameAmount;
	}



	public void setMarkoKopurua(int markoKopurua) {
		mmFrameAmount = markoKopurua;
	}
}